package de.intevation.flys.client.client.services;

import com.google.gwt.user.client.rpc.RemoteService;
import com.google.gwt.user.client.rpc.RemoteServiceRelativePath;

import de.intevation.flys.client.shared.exceptions.ServerException;
import de.intevation.flys.client.shared.model.Artifact;

/**
 * This interface provides artifact specific operation DESCRIBE.
 *
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
@RemoteServiceRelativePath("describe")
public interface DescribeArtifactService extends RemoteService {

    /**
     * This method inserts new data into the an existing artifact.
     *
     * @param url The url of the artifact server.
     * @param locale The locale used for the request.
     * @param artifact The artifact.
     *
     * @return the artifact which description might have been changed.
     */
    public Artifact describe(
        String   url,
        String   locale,
        Artifact artifact)
    throws ServerException;
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
